Module javafx.controls
Package javafx.scene.control.cell

# Class ChoiceBoxTreeCell<T>

java.lang.Object
javafx.scene.Node
javafx.scene.Parent
javafx.scene.layout.Region
javafx.scene.control.Control
javafx.scene.control.Labeled
javafx.scene.control.Cell<T>
javafx.scene.control.IndexedCell<T>
javafx.scene.control.TreeCell<T>
javafx.scene.control.cell.ChoiceBoxTreeCell<T>

Type Parameters:
  `T` - The type of the TreeItems contained within the TreeView.

All Implemented Interfaces:
  `Styleable`, `EventTarget`, `Skinnable`

public class ChoiceBoxTreeCell<T> extends TreeCell<T>
A class containing a `ListCell` implementation that draws a `ChoiceBox` node inside the cell.

By default, the ChoiceBoxTreeCell is rendered as a `Label` when not being edited, and as a ChoiceBox when in editing mode. The ChoiceBox will, by default, stretch to fill the entire tree cell.

To create a ChoiceBoxTreeCell, it is necessary to provide zero or more items that will be shown to the user when the `ChoiceBox` menu is showing. These items must be of the same type as the TreeView TreeItems, such that upon selection, they replace the existing value in the `TreeItem.valueProperty()`.

Since:
  JavaFX 2.2

## Property Summary

Properties
Type
Property
Description
`final ObjectProperty<StringConverter<T>>`
`converter`
The `StringConverter` property.

### Properties inherited from class javafx.scene.control.TreeCell

`disclosureNode, treeItem, treeView`

### Properties inherited from class javafx.scene.control.IndexedCell

`index`

### Properties inherited from class javafx.scene.control.Cell

`editable, editing, empty, item, selected`

### Properties inherited from class javafx.scene.control.Labeled

`alignment, contentDisplay, ellipsisString, font, graphic, graphicTextGap, labelPadding, lineSpacing, mnemonicParsing, textAlignment, textFill, textOverrun, text, underline, wrapText`

### Properties inherited from class javafx.scene.control.Control

`contextMenu, skin, tooltip`

### Properties inherited from class javafx.scene.layout.Region

`background, border, cacheShape, centerShape, height, insets, maxHeight, maxWidth, minHeight, minWidth, opaqueInsets, padding, prefHeight, prefWidth, scaleShape, shape, snapToPixel, width`

### Properties inherited from class javafx.scene.Parent

`needsLayout`

### Properties inherited from class javafx.scene.Node

`accessibleHelp, accessibleRoleDescription, accessibleRole, accessibleText, blendMode, boundsInLocal, boundsInParent, cacheHint, cache, clip, cursor, depthTest, disabled, disable, effectiveNodeOrientation, effect, eventDispatcher, focused, focusTraversable, hover, id, inputMethodRequests, layoutBounds, layoutX, layoutY, localToParentTransform, localToSceneTransform, managed, mouseTransparent, nodeOrientation, onContextMenuRequested, onDragDetected, onDragDone, onDragDropped, onDragEntered, onDragExited, onDragOver, onInputMethodTextChanged, onKeyPressed, onKeyReleased, onKeyTyped, onMouseClicked, onMouseDragEntered, onMouseDragExited, onMouseDragged, onMouseDragOver, onMouseDragReleased, onMouseEntered, onMouseExited, onMouseMoved, onMousePressed, onMouseReleased, onRotate, onRotationFinished, onRotationStarted, onScrollFinished, onScroll, onScrollStarted, onSwipeDown, onSwipeLeft, onSwipeRight, onSwipeUp, onTouchMoved, onTouchPressed, onTouchReleased, onTouchStationary, onZoomFinished, onZoom, onZoomStarted, opacity, parent, pickOnBounds, pressed, rotate, rotationAxis, scaleX, scaleY, scaleZ, scene, style, translateX, translateY, translateZ, viewOrder, visible`

## Field Summary

### Fields inherited from class javafx.scene.layout.Region

`USE_COMPUTED_SIZE, USE_PREF_SIZE`

### Fields inherited from class javafx.scene.Node

`BASELINE_OFFSET_SAME_AS_HEIGHT`

## Constructor Summary

Constructors
Constructor
Description
`ChoiceBoxTreeCell()`
Creates a default ChoiceBoxTreeCell with an empty items list.
`ChoiceBoxTreeCell(ObservableList<T> items)`
Creates a default `ChoiceBoxTreeCell` instance with the given items being used to populate the `ChoiceBox` when it is shown.
`ChoiceBoxTreeCell(StringConverter<T> converter, ObservableList<T> items)`
Creates a `ChoiceBoxTreeCell` instance with the given items being used to populate the `ChoiceBox` when it is shown, and the `StringConverter` being used to convert the item in to a user-readable form.
`ChoiceBoxTreeCell(StringConverter<T> converter, T... items)`
Creates a `ChoiceBoxTreeCell` instance with the given items being used to populate the `ChoiceBox` when it is shown, and the `StringConverter` being used to convert the item in to a user-readable form.
`ChoiceBoxTreeCell(T... items)`
Creates a default `ChoiceBoxTreeCell` instance with the given items being used to populate the `ChoiceBox` when it is shown.

## Method Summary

Modifier and Type
Method
Description
`void`
`cancelEdit()`
Call this function to transition from an editing state into a non-editing state, without saving any user input.
`final ObjectProperty<StringConverter<T>>`
`converterProperty()`
The `StringConverter` property.
`static <T> Callback<TreeView<T>,TreeCell<T>>`
`forTreeView(ObservableList<T> items)`
Creates a ChoiceBox cell factory for use in `TreeView` controls.
`static <T> Callback<TreeView<T>,TreeCell<T>>`
`forTreeView(StringConverter<T> converter, ObservableList<T> items)`
Creates a ChoiceBox cell factory for use in `TreeView` controls.
`static <T> Callback<TreeView<T>,TreeCell<T>>`
`forTreeView(StringConverter<T> converter, T... items)`
Creates a ChoiceBox cell factory for use in `TreeView` controls.
`static <T> Callback<TreeView<T>,TreeCell<T>>`
`forTreeView(T... items)`
Creates a ChoiceBox cell factory for use in `TreeView` controls.
`final StringConverter<T>`
`getConverter()`
Returns the `StringConverter` used in this cell.
`ObservableList<T>`
`getItems()`
Returns the items to be displayed in the ChoiceBox when it is showing.
`final void`
`setConverter(StringConverter<T> value)`
Sets the `StringConverter` to be used in this cell.
`void`
`startEdit()`
Call this function to transition from a non-editing state into an editing state, if the cell is editable.
`void`
`updateItem(T item, boolean empty)`
The updateItem method should not be called by developers, but it is the best method for developers to override to allow for them to customise the visuals of the cell.

### Methods inherited from class javafx.scene.control.TreeCell

`commitEdit, createDefaultSkin, disclosureNodeProperty, executeAccessibleAction, getDisclosureNode, getTreeItem, getTreeView, queryAccessibleAttribute, setDisclosureNode, treeItemProperty, treeViewProperty, updateTreeItem, updateTreeView`

### Methods inherited from class javafx.scene.control.IndexedCell

`getIndex, indexProperty, updateIndex`

### Methods inherited from class javafx.scene.control.Cell

`editableProperty, editingProperty, emptyProperty, getInitialFocusTraversable, getItem, isEditable, isEditing, isEmpty, isItemChanged, isSelected, itemProperty, layoutChildren, selectedProperty, setEditable, setItem, updateSelected`

### Methods inherited from class javafx.scene.control.Labeled

`alignmentProperty, contentDisplayProperty, ellipsisStringProperty, fontProperty, getAlignment, getClassCssMetaData, getContentBias, getContentDisplay, getControlCssMetaData, getEllipsisString, getFont, getGraphic, getGraphicTextGap, getInitialAlignment, getLabelPadding, getLineSpacing, getText, getTextAlignment, getTextFill, getTextOverrun, graphicProperty, graphicTextGapProperty, isMnemonicParsing, isUnderline, isWrapText, labelPaddingProperty, lineSpacingProperty, mnemonicParsingProperty, setAlignment, setContentDisplay, setEllipsisString, setFont, setGraphic, setGraphicTextGap, setLineSpacing, setMnemonicParsing, setText, setTextAlignment, setTextFill, setTextOverrun, setUnderline, setWrapText, textAlignmentProperty, textFillProperty, textOverrunProperty, textProperty, toString, underlineProperty, wrapTextProperty`

### Methods inherited from class javafx.scene.control.Control

`computeMaxHeight, computeMaxWidth, computeMinHeight, computeMinWidth, computePrefHeight, computePrefWidth, contextMenuProperty, getBaselineOffset, getContextMenu, getCssMetaData, getSkin, getTooltip, isResizable, setContextMenu, setSkin, setTooltip, skinProperty, tooltipProperty`

### Methods inherited from class javafx.scene.layout.Region

`backgroundProperty, borderProperty, cacheShapeProperty, centerShapeProperty, getBackground, getBorder, getHeight, getInsets, getMaxHeight, getMaxWidth, getMinHeight, getMinWidth, getOpaqueInsets, getPadding, getPrefHeight, getPrefWidth, getShape, getUserAgentStylesheet, getWidth, heightProperty, insetsProperty, isCacheShape, isCenterShape, isScaleShape, isSnapToPixel, layoutInArea, layoutInArea, layoutInArea, layoutInArea, maxHeight, maxHeightProperty, maxWidth, maxWidthProperty, minHeight, minHeightProperty, minWidth, minWidthProperty, opaqueInsetsProperty, paddingProperty, positionInArea, positionInArea, prefHeight, prefHeightProperty, prefWidth, prefWidthProperty, resize, scaleShapeProperty, setBackground, setBorder, setCacheShape, setCenterShape, setHeight, setMaxHeight, setMaxSize, setMaxWidth, setMinHeight, setMinSize, setMinWidth, setOpaqueInsets, setPadding, setPrefHeight, setPrefSize, setPrefWidth, setScaleShape, setShape, setSnapToPixel, setWidth, shapeProperty, snappedBottomInset, snappedLeftInset, snappedRightInset, snappedTopInset, snapPosition, snapPositionX, snapPositionY, snapSize, snapSizeX, snapSizeY, snapSpace, snapSpaceX, snapSpaceY, snapToPixelProperty, widthProperty`

### Methods inherited from class javafx.scene.Parent

`getChildren, getChildrenUnmodifiable, getManagedChildren, getStylesheets, isNeedsLayout, layout, lookup, needsLayoutProperty, requestLayout, requestParentLayout, setNeedsLayout, updateBounds`

### Methods inherited from class javafx.scene.Node

`accessibleHelpProperty, accessibleRoleDescriptionProperty, accessibleRoleProperty, accessibleTextProperty, addEventFilter, addEventHandler, applyCss, autosize, blendModeProperty, boundsInLocalProperty, boundsInParentProperty, buildEventDispatchChain, cacheHintProperty, cacheProperty, clipProperty, computeAreaInScreen, contains, contains, cursorProperty, depthTestProperty, disabledProperty, disableProperty, effectiveNodeOrientationProperty, effectProperty, eventDispatcherProperty, fireEvent, focusedProperty, focusTraversableProperty, getAccessibleHelp, getAccessibleRole, getAccessibleRoleDescription, getAccessibleText, getBlendMode, getBoundsInLocal, getBoundsInParent, getCacheHint, getClip, getCursor, getDepthTest, getEffect, getEffectiveNodeOrientation, getEventDispatcher, getId, getInitialCursor, getInputMethodRequests, getLayoutBounds, getLayoutX, getLayoutY, getLocalToParentTransform, getLocalToSceneTransform, getNodeOrientation, getOnContextMenuRequested, getOnDragDetected, getOnDragDone, getOnDragDropped, getOnDragEntered, getOnDragExited, getOnDragOver, getOnInputMethodTextChanged, getOnKeyPressed, getOnKeyReleased, getOnKeyTyped, getOnMouseClicked, getOnMouseDragEntered, getOnMouseDragExited, getOnMouseDragged, getOnMouseDragOver, getOnMouseDragReleased, getOnMouseEntered, getOnMouseExited, getOnMouseMoved, getOnMousePressed, getOnMouseReleased, getOnRotate, getOnRotationFinished, getOnRotationStarted, getOnScroll, getOnScrollFinished, getOnScrollStarted, getOnSwipeDown, getOnSwipeLeft, getOnSwipeRight, getOnSwipeUp, getOnTouchMoved, getOnTouchPressed, getOnTouchReleased, getOnTouchStationary, getOnZoom, getOnZoomFinished, getOnZoomStarted, getOpacity, getParent, getProperties, getPseudoClassStates, getRotate, getRotationAxis, getScaleX, getScaleY, getScaleZ, getScene, getStyle, getStyleableParent, getStyleClass, getTransforms, getTranslateX, getTranslateY, getTranslateZ, getTypeSelector, getUserData, getViewOrder, hasProperties, hoverProperty, idProperty, inputMethodRequestsProperty, intersects, intersects, isCache, isDisable, isDisabled, isFocused, isFocusTraversable, isHover, isManaged, isMouseTransparent, isPickOnBounds, isPressed, isVisible, layoutBoundsProperty, layoutXProperty, layoutYProperty, localToParent, localToParent, localToParent, localToParent, localToParent, localToParentTransformProperty, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToSceneTransformProperty, localToScreen, localToScreen, localToScreen, localToScreen, localToScreen, lookupAll, managedProperty, mouseTransparentProperty, nodeOrientationProperty, notifyAccessibleAttributeChanged, onContextMenuRequestedProperty, onDragDetectedProperty, onDragDoneProperty, onDragDroppedProperty, onDragEnteredProperty, onDragExitedProperty, onDragOverProperty, onInputMethodTextChangedProperty, onKeyPressedProperty, onKeyReleasedProperty, onKeyTypedProperty, onMouseClickedProperty, onMouseDragEnteredProperty, onMouseDragExitedProperty, onMouseDraggedProperty, onMouseDragOverProperty, onMouseDragReleasedProperty, onMouseEnteredProperty, onMouseExitedProperty, onMouseMovedProperty, onMousePressedProperty, onMouseReleasedProperty, onRotateProperty, onRotationFinishedProperty, onRotationStartedProperty, onScrollFinishedProperty, onScrollProperty, onScrollStartedProperty, onSwipeDownProperty, onSwipeLeftProperty, onSwipeRightProperty, onSwipeUpProperty, onTouchMovedProperty, onTouchPressedProperty, onTouchReleasedProperty, onTouchStationaryProperty, onZoomFinishedProperty, onZoomProperty, onZoomStartedProperty, opacityProperty, parentProperty, parentToLocal, parentToLocal, parentToLocal, parentToLocal, parentToLocal, pickOnBoundsProperty, pressedProperty, pseudoClassStateChanged, relocate, removeEventFilter, removeEventHandler, requestFocus, resizeRelocate, rotateProperty, rotationAxisProperty, scaleXProperty, scaleYProperty, scaleZProperty, sceneProperty, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, screenToLocal, screenToLocal, screenToLocal, setAccessibleHelp, setAccessibleRole, setAccessibleRoleDescription, setAccessibleText, setBlendMode, setCache, setCacheHint, setClip, setCursor, setDepthTest, setDisable, setDisabled, setEffect, setEventDispatcher, setEventHandler, setFocused, setFocusTraversable, setHover, setId, setInputMethodRequests, setLayoutX, setLayoutY, setManaged, setMouseTransparent, setNodeOrientation, setOnContextMenuRequested, setOnDragDetected, setOnDragDone, setOnDragDropped, setOnDragEntered, setOnDragExited, setOnDragOver, setOnInputMethodTextChanged, setOnKeyPressed, setOnKeyReleased, setOnKeyTyped, setOnMouseClicked, setOnMouseDragEntered, setOnMouseDragExited, setOnMouseDragged, setOnMouseDragOver, setOnMouseDragReleased, setOnMouseEntered, setOnMouseExited, setOnMouseMoved, setOnMousePressed, setOnMouseReleased, setOnRotate, setOnRotationFinished, setOnRotationStarted, setOnScroll, setOnScrollFinished, setOnScrollStarted, setOnSwipeDown, setOnSwipeLeft, setOnSwipeRight, setOnSwipeUp, setOnTouchMoved, setOnTouchPressed, setOnTouchReleased, setOnTouchStationary, setOnZoom, setOnZoomFinished, setOnZoomStarted, setOpacity, setPickOnBounds, setPressed, setRotate, setRotationAxis, setScaleX, setScaleY, setScaleZ, setStyle, setTranslateX, setTranslateY, setTranslateZ, setUserData, setViewOrder, setVisible, snapshot, snapshot, startDragAndDrop, startFullDrag, styleProperty, toBack, toFront, translateXProperty, translateYProperty, translateZProperty, usesMirroring, viewOrderProperty, visibleProperty`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface javafx.css.Styleable

`getStyleableNode`

## Property Details

### converter

public final ObjectProperty<StringConverter<T>> converterProperty
The `StringConverter` property.

See Also:
  - `converterProperty()`

## Constructor Details

### ChoiceBoxTreeCell

public ChoiceBoxTreeCell()
Creates a default ChoiceBoxTreeCell with an empty items list.

### ChoiceBoxTreeCell

@SafeVarargs public ChoiceBoxTreeCell(T... items)
Creates a default `ChoiceBoxTreeCell` instance with the given items being used to populate the `ChoiceBox` when it is shown.

Parameters:
  `items` - The items to show in the ChoiceBox popup menu when selected by the user.

### ChoiceBoxTreeCell

@SafeVarargs public ChoiceBoxTreeCell(StringConverter<T> converter, T... items)
Creates a `ChoiceBoxTreeCell` instance with the given items being used to populate the `ChoiceBox` when it is shown, and the `StringConverter` being used to convert the item in to a user-readable form.

Parameters:
  `converter` - A `Callback` that can convert an item of type T into a user-readable string so that it may then be shown in the ChoiceBox popup menu.
  `items` - The items to show in the ChoiceBox popup menu when selected by the user.

### ChoiceBoxTreeCell

public ChoiceBoxTreeCell(ObservableList<T> items)
Creates a default `ChoiceBoxTreeCell` instance with the given items being used to populate the `ChoiceBox` when it is shown.

Parameters:
  `items` - The items to show in the ChoiceBox popup menu when selected by the user.

### ChoiceBoxTreeCell

public ChoiceBoxTreeCell(StringConverter<T> converter, ObservableList<T> items)
Creates a `ChoiceBoxTreeCell` instance with the given items being used to populate the `ChoiceBox` when it is shown, and the `StringConverter` being used to convert the item in to a user-readable form.

Parameters:
  `converter` - A `Callback` that can convert an item of type T into a user-readable string so that it may then be shown in the ChoiceBox popup menu.
  `items` - The items to show in the ChoiceBox popup menu when selected by the user.

## Method Details

### forTreeView

@SafeVarargs public static <T> Callback<TreeView<T>,TreeCell<T>> forTreeView(T... items)
Creates a ChoiceBox cell factory for use in `TreeView` controls. By default, the ChoiceBoxCell is rendered as a `Label` when not being edited, and as a ChoiceBox when in editing mode. The ChoiceBox will, by default, stretch to fill the entire tree cell.

Type Parameters:
  `T` - The type of the elements contained within the TreeView.
Parameters:
  `items` - Zero or more items that will be shown to the user when the `ChoiceBox` menu is showing. These items must be of the same type as the TreeView<T>, such that upon selection, they replace the existing value in the TreeItem `value` property.
Returns:
  A `Callback` that will return a TreeCell that is able to work on the type of element contained within the TreeView.

### forTreeView

public static <T> Callback<TreeView<T>,TreeCell<T>> forTreeView(ObservableList<T> items)
Creates a ChoiceBox cell factory for use in `TreeView` controls. By default, the ChoiceBoxCell is rendered as a `Label` when not being edited, and as a ChoiceBox when in editing mode. The ChoiceBox will, by default, stretch to fill the entire tree cell, excluding the space allocated to the tree cell indentation and disclosure node (i.e. the arrow).

Type Parameters:
  `T` - The type of the `TreeItem` elements contained within the TreeView.
Parameters:
  `items` - An `ObservableList` containing zero or more items that will be shown to the user when the `ChoiceBox` menu is showing. These items must be of the same type as the TreeView generic type, such that upon selection, they replace the existing value in the `TreeItem` that is being edited (as noted in the `TreeView.editingItemProperty()`.
Returns:
  A `Callback` that will return a TreeCell that is able to work on the type of element contained within the TreeView.

### forTreeView

@SafeVarargs public static <T> Callback<TreeView<T>,TreeCell<T>> forTreeView(StringConverter<T> converter, T... items)
Creates a ChoiceBox cell factory for use in `TreeView` controls. By default, the ChoiceBoxCell is rendered as a `Label` when not being edited, and as a ChoiceBox when in editing mode. The ChoiceBox will, by default, stretch to fill the entire tree cell.

Type Parameters:
  `T` - The type of the elements contained within the TreeView.
Parameters:
  `converter` - A `StringConverter` to convert the given item (of type T) to a String for displaying to the user.
  `items` - Zero or more items that will be shown to the user when the `ChoiceBox` menu is showing. These items must be of the same type as the TreeView<T>, such that upon selection, they replace the existing value in the TreeItem `value` property.
Returns:
  A `Callback` that will return a TreeCell that is able to work on the type of element contained within the TreeView.

### forTreeView

public static <T> Callback<TreeView<T>,TreeCell<T>> forTreeView(StringConverter<T> converter, ObservableList<T> items)
Creates a ChoiceBox cell factory for use in `TreeView` controls. By default, the ChoiceBoxCell is rendered as a `Label` when not being edited, and as a ChoiceBox when in editing mode. The ChoiceBox will, by default, stretch to fill the entire tree cell.

Type Parameters:
  `T` - The type of the elements contained within the TreeView.
Parameters:
  `converter` - A `StringConverter` to convert the given item (of type T) to a String for displaying to the user.
  `items` - An `ObservableList` containing zero or more items that will be shown to the user when the `ChoiceBox` menu is showing. These items must be of the same type as the TreeView generic type, such that upon selection, they replace the existing value in the `TreeItem` that is being edited (as noted in the `TreeView.editingItemProperty()`.
Returns:
  A `Callback` that will return a TreeCell that is able to work on the type of element contained within the TreeView.

### converterProperty

public final ObjectProperty<StringConverter<T>> converterProperty()
The `StringConverter` property.

Returns:
  the `StringConverter` property

### setConverter

public final void setConverter(StringConverter<T> value)
Sets the `StringConverter` to be used in this cell.

Parameters:
  `value` - the `StringConverter` to be used in this cell

### getConverter

public final StringConverter<T> getConverter()
Returns the `StringConverter` used in this cell.

Returns:
  the `StringConverter` used in this cell

### getItems

public ObservableList<T> getItems()
Returns the items to be displayed in the ChoiceBox when it is showing.

Returns:
  the items to be displayed in the ChoiceBox when it is showing

### startEdit

public void startEdit()
Call this function to transition from a non-editing state into an editing state, if the cell is editable. If this cell is already in an editing state, it will stay in it.

Overrides:
  `startEdit` in class `TreeCell<T>`

### cancelEdit

public void cancelEdit()
Call this function to transition from an editing state into a non-editing state, without saving any user input.

Overrides:
  `cancelEdit` in class `TreeCell<T>`

### updateItem

public void updateItem(T item, boolean empty)
The updateItem method should not be called by developers, but it is the best method for developers to override to allow for them to customise the visuals of the cell. To clarify, developers should never call this method in their code (they should leave it up to the UI control, such as the `ListView` control) to call this method. However, the purpose of having the updateItem method is so that developers, when specifying custom cell factories (again, like the ListView `cell factory`), the updateItem method can be overridden to allow for complete customisation of the cell.

It is very important that subclasses of Cell override the updateItem method properly, as failure to do so will lead to issues such as blank cells or cells with unexpected content appearing within them. Here is an example of how to properly override the updateItem method:

     protected void updateItem(T item, boolean empty) {
         super.updateItem(item, empty);

         if (empty || item == null) {
             setText(null);
             setGraphic(null);
         } else {
             setText(item.toString());
         }
     }

Note in this code sample two important points:

1. We call the super.updateItem(T, boolean) method. If this is not done, the item and empty properties are not correctly set, and you are likely to end up with graphical issues.
2. We test for the `empty` condition, and if true, we set the text and graphic properties to null. If we do not do this, it is almost guaranteed that end users will see graphical artifacts in cells unexpectedly.

Parameters:
  `item` - The new item for the cell.
  `empty` - whether or not this cell represents data from the list. If it is empty, then it does not represent any domain data, but is a cell being used to render an "empty" row.